/*

    MiniM ZDLL example 2

    ZDLL module export several functions to illistrate ZDLL interface usage.

*/

#include <windows.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

#include "zdll.h"

// zdll function which called from minim
int __stdcall getdate( ZDLLCB* cbfunc, MINIM_STR* result,
  int argc, MINIM_STR** argv)
{
  // evaluate special expression "$zd($h,13)"
  // here we call cbfunc->Eval and use as result argument result

  MINIM_STR expr;
  expr.len = sprintf( expr.data, "$zd($h,13)");

  cbfunc->Eval( &expr, result);

  return 0;
};

// declare array of function definitions
ZDLLFUNC functions[] =
{
  { getdate, "getdate"},
  { NULL, NULL }
};

// root export
#ifdef __cplusplus
extern "C"
#endif
__declspec( dllexport ) ZDLLFUNC* __stdcall ZDLL ( void)
{
  return functions;
};

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  return 1;
};
