/*

    MiniM ZDLL example 3

    ZDLL module export several functions to illistrate ZDLL interface usage.

*/

#include <windows.h>

#include <windows.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

#include "zdll.h"

// zdll function which called from minim
int __stdcall set( ZDLLCB* cbfunc, MINIM_STR* result,
  int argc, MINIM_STR** argv)
{
  // call minim and set variables
  // s a(1)=1
  // s a(2)=2

  MINIM_STR str;
  str.len = sprintf( str.data, "s a(1)=1");
  cbfunc->Execute( &str);

  str.len = sprintf( str.data, "s a(2)=2");
  cbfunc->Execute( &str);

  return 0;
};

// declare array of function definitions
ZDLLFUNC functions[] =
{
  { set, "set"},
  { NULL, NULL }
};

// root export
#ifdef __cplusplus
extern "C"
#endif
__declspec( dllexport ) ZDLLFUNC* __stdcall ZDLL ( void)
{
  return functions;
};

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  return 1;
};
 