/*

    MiniMono Example 1

    (C) Eugene Karataev

    http://www.minimdb.com
    support@minimdb.com


    Example demonstrates how to load, initialize and free
    MiniMono virtual machine and evaluate MUMPS expressions

*/

class example1
{
	public static void main(String[] args)
	{
		try
		{
			String CodePage = "Cp1251";
			System.out.println("Java example1 how to call MiniMono");

			minimonoj MiniMono = new minimonoj( CodePage);
			minimonoj.MiniMonoVM init = new minimonoj.MiniMonoVM( CodePage);

			MiniMono.GetDefaultSettings( init);

			init.DataFile = "sys.dat";
			init.JournalingEnabled = 0;

			int ret = MiniMono.CreateMiniMono( init);
			System.out.println("MiniMono creation error: " + ret);
			
			System.out.println( "Value of $zversion: " + MiniMono.Read( "$zversion"));

			System.out.println( "Now is: " + MiniMono.Read( "$zdate($h,3)"));

			MiniMono.FreeMiniMono();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};